/**
 *	@file	FavoriteOrder.h
 *	@brief	WXgɂ邨Cɓ𑀍삵ĕяNX
 */
#pragma once

#include "ItemIDList.h"
#include "MtlFile.h"
#include "MtlWeb.h"


#define REGKEY_IE_MENUORDER_ROOT	_T("Software\\Microsoft\\Windows\\CurrentVersion\\Explorer\\MenuOrder\\Favorites")



/// WXgɂ邨Cɓ𑀍삵ĕяNX
/// Ƀf[^jȂ悤ɋC邱
class CFavoriteOrderHandler {
private:
	enum EIe_MenuOrder {
		IE_MENUORDER_ITEM		= 0x05,
		IE_MENUORDER_FOLDER 	= 0x0D,
		IE_MENUORDER_ZERO		= 0x00,

		IE_MENUORDER_UNKNOWN1	= 2,
		IE_MENUORDER_UNKNOWN2	= 1,
	};

	struct OrderDataHeader {
		DWORD		dwSize8;				///< 8Œ
		DWORD		dwUnknown;				///< s l͏2
		DWORD		dwFullSizem8;			///< f[^Ŝ̃TCY-8
		DWORD		dwUnknown2; 			///< s l͏1
		DWORD		dwItemCount;			///< ACě
	};

	struct OrderItemTemplate {
		DWORD		dwSize;
		DWORD		dwPosition;
		ITEMIDLIST	idlName;
	};

	struct OrderItemData {
		DWORD		dwSize; 				///< ڂ̃f[^TCY
		DWORD		dwPosition; 			///< ڂ̈ʒuZero Origin
		CItemIDList idlName;				///< t@Ĉ݂ITEMIDLIST
		BOOL		bPadding;
		DWORD		dwFlag;
		CString 	strName;				///< t@C
		BOOL		bRef;

	  #if 1 //+++
		OrderItemData()
			: dwSize(0), dwPosition(0), idlName(), bPadding(0), dwFlag(0), strName(), bRef(0)
		{
		}
	  #endif
	};

	enum { s_itemsize_without_idl = 12 };	///< idlName\̃TCY


	typedef std::vector<OrderItemData>	FavoriteDataArray;

public:
	FavoriteDataArray	m_aryData;
	CString 			m_strDirPath;

private:
	CString 			m_strRegKey;

public:
	CFavoriteOrderHandler();
	~CFavoriteOrderHandler();

	/// WXgf[^ǂݍ
	BOOL	ReadData(const CString &strDirPath);
	BOOL	MoveData(DWORD dwSrcPos, DWORD dwDstPos);

	/// f[^WXgɏ
	BOOL	SaveData();

	/// f[^\z
	BOOL	ReConstructData(CString strDirPath);

	/// w肵Oڂ̔ԍԂ
	int 	FindName(const CString &strFileName);

	/// w肵ʒuɂ鍀ڂ̔ԍԂ
	int 	FindPosition(DWORD dwPosition);

	CString GetOrderKeyName(const CString &strDirPath);


private:
	/// f[^ǉ
	BOOL	AddData(CString strFileName, DWORD dwPosition); 	// m_strDirPath̑΃pXŎw
	BOOL	DeleteData(CString strFileName);


	struct _FavoriteItemCollector {
		FavoriteDataArray&	_aryData;
		CString &			_strDirPath;
		CItemIDList 		_idlFolder;

		_FavoriteItemCollector(CString &strDirPath, FavoriteDataArray &aryData)
			: _aryData(aryData)
			, _strDirPath(strDirPath)
			, _idlFolder( _strDirPath )
		{
		}


		void operator ()(const CString &strPath, bool bDir)
		{
			OrderItemData	item;

			item.strName	= MTL::MtlGetFileName(strPath);
			FavoriteDataArray::iterator it;
			for (it = _aryData.begin(); it != _aryData.end(); ++it) {
				if (item.strName == it->strName) {
					it->bRef = TRUE;
					return;
				}
			}

			item.idlName	= strPath;
			item.idlName   -= _idlFolder;
			item.dwPosition = FAVORITESORDER_NOTFOUND; //ŏԕt邽߂̓l
			int 	nSize	= item.idlName.GetSize();
			item.bPadding	= (nSize & 1);		//+++ ? TRUE : FALSE;
			item.dwSize 	= nSize + s_itemsize_without_idl + (item.bPadding /*+++ ? 1 : 0*/);
			item.dwFlag 	= bDir ? IE_MENUORDER_FOLDER : IE_MENUORDER_ITEM;
			item.bRef		= TRUE;
			_aryData.push_back(item);
		}
	};


	struct _FavoritesMenuNameCompare : public std::binary_function<const OrderItemData &, const OrderItemData &, bool> {
		CString 	_strDirPath;

		_FavoritesMenuNameCompare(CString strDirPath)
			: _strDirPath(strDirPath)
		{
		}


		bool operator ()(const OrderItemData &x, const OrderItemData &y) const
		{
			CItemIDList idlDir = _strDirPath;
			CItemIDList idlX   = idlDir 	;	idlX += x.idlName;
			CItemIDList idlY   = idlDir 	;	idlY += y.idlName;
			CString 	strX   = idlX.GetPath();
			CString 	strY   = idlY.GetPath();

			if ( MtlIsDirectory(strX) ) {
				if ( MtlIsDirectory(strY) ) {
					return ::lstrcmp(strX, strY) < 0;
				} else {
					return true;
				}
			} else {
				if ( MtlIsDirectory(strY) ) {
					return false;
				} else {
					return ::lstrcmp(strX, strY) < 0;
				}
			}
		}
	};

};
