/**
 *	@file	SearchBar.h
 *	@brief	o[
 *	@note
 *		templateŎĂ SearchBar.h 𕁒ʂclassɂ .h, .cpp .
 */

#ifndef SEARCHBAR_H
#define SEARCHBAR_H
#pragma once

enum ESts {
	STS_ENG_CHANGE_GO		=	0x00000001,
	STS_DROP_GO 			=	0x00000002,
	STS_HISTORY_SAVE		=	0x00000004,
	STS_NO_REPOSITION		=	0x00000008,
	STS_KEY_CHANGE_GO		=	0x00000010,
	STS_HEIGHTCOUNT 		=	0x00000020,
	STS_TEXT_FILTER 		=	0x00000040,
	STS_LASTSEL 			=	0x00000080,
	STS_SCROLLCENTER		=	0x00000100,
	STS_ACTIVEWINDOW		=	0x00000200,
	STS_AUTOHILIGHT 		=	0x00000400,
};


enum {
	DEFAULT_HEIGHTCOUNT 	=  25,
	MAXHEIGHTCOUNT			= 100,
};



extern bool 		g_bNoReposition;


class CDonutSearchBar
	: public CDialogImpl< CDonutSearchBar >
	, public IDropTargetImpl< CDonutSearchBar >
	, public IDropSourceImpl< CDonutSearchBar >
{
public:
	enum { IDD = IDD_SEARCHBAR_FORM };

private:
	typedef CDonutSearchBar 	thisClass;

	enum {
		STB_SHOWTOOLBARICON 	= 0x00000001,
	};

	enum EEnt_Read {
		ENT_READ_ENG			=	1,
		ENT_READ_HIST			=	2,
	};


	enum EEnter_KeyDown {
		ENTER_KEYDOWN_RETURN	=	0,
		ENTER_KEYDOWN_SELCHANGE =	1,
	};


	enum ECharEncode {
		ENCODE_NONE 			=	0,
		ENCODE_SHIFT_JIS		=	1,
		ENCODE_EUC				=	2,
		ENCODE_UTF8 			=	3,
	};

	CFlatComboBox	 m_cmbKeyword;


public:
	CFlatComboBox	 m_cmbEngine;
	CToolBarCtrl	 m_wndToolBar;


private:
	//x HANDLE		 m_hThreadEngine;		//+++ gpۂ
	//x HANDLE		 m_hThreadKeyword;		//+++ gpۂ
	HCURSOR 		 m_hCursor;
	CPoint			 m_ptDragHist;
	CPoint			 m_ptDragStart;
	CPoint			 m_ptDragEnd;
	CContainedWindow m_wndKeyword;
	CContainedWindow m_wndEngine;

	enum {
		m_nBarCX	=  2,
		m_nBmpCX	= 16,
		m_nBmpCY	= 16,
		s_kcxGap	=  2
	};

	enum {
		m_nDefEditT =  1,
		//+++ m_nDefDlgH	= 22
	};
	int 			 m_nDefDlgH;					///+++ ϐ
	int 			 m_nItemFontH;					///< +++ tHg̍狁߂ACe̍
	bool			 m_bDragAccept;
	bool			 m_bDragFromItself;
	int 			 m_cxBtnsBtn;					///<  p
	BOOL			 m_bShowToolBar;
	BOOL			 m_bLoadedToolBar;
	BOOL			 m_bFiltering;					///< +++ SpXy[X𔼊pɕϊꍇtrue.
	int 			 m_clrMask;
	BOOL			 m_bActiveWindow;
	HWND			 m_hWndKeywordList;
	CContainedWindow m_wndKeywordCombo;

	//option
	BOOL			 m_bUseShortcut;

	struct _ThreadParam {
		thisClass *  m_pSearchBar;
		HANDLE		 m_hExitEvent;
	};

	_ThreadParam	 m_ThreadParams;
	HANDLE			 m_hThread;
	int 			 m_has; 						//+++
	CString 		 m_toolBarAddWordStr;			//+++ PꂪVɕύXꂽ̃`FbNp
	DWORD			 m_dwNoWordButton;				//+++ P{^Ȃtrue(Lɂ)
	DWORD			 m_dwUsePageButton;				//+++ P{^gpɂPƂ̃y[W{^g
	int 			 m_nKeywordWidth;				//+++
	int 			 m_nEngineWidth;					//+++

	//+++ 1CX^XȂA낤ƂāAParseInternetShortcutFile()pɎ蔲Ȏw|C^.
	static CDonutSearchBar* s_pThis_;

public:
	CDonutSearchBar();
	~CDonutSearchBar() { s_pThis_ = NULL; } 	//+++ 蔲̐K@.

	const CDonutSearchBar* instance_ptr() const { return s_pThis_; }	//+++

	// Message map and handlers
	BEGIN_MSG_MAP(CDonutSearchBarEx)
		MSG_WM_INITDIALOG	(OnInitDialog	)
		MSG_WM_DESTROY		(OnDestroy		)
		MSG_WM_MOUSEMOVE	(OnMouseMove	)
		MSG_WM_LBUTTONDOWN	(OnLButtonDown	)
		MSG_WM_LBUTTONUP	(OnLButtonUp	)
		MSG_WM_COMMAND		(OnCommand		)
		NOTIFY_CODE_HANDLER (TTN_GETDISPINFO, OnToolTipText)

		MESSAGE_HANDLER 	(WM_SIZE		, OnSize	   )
		MESSAGE_HANDLER 	(WM_ERASEBKGND	, OnEraseBkgnd )
		//COMMAND_HANDLER_EX	(IDC_CMB_ENGIN	, CBN_DBLCLK   , OnSelDblClkForEngine)
		COMMAND_HANDLER_EX	(IDC_CMB_ENGIN	, CBN_SELCHANGE, OnSelChangeForEngine)
		COMMAND_HANDLER_EX	(IDC_CMB_KEYWORD, CBN_SELCHANGE, OnSelChange)
	  #if SEARCH_JIKKEN == 1	//+++
		NOTIFY_CODE_HANDLER(RBN_CHEVRONPUSHED, OnChevronPushed) //+++
	  #elif SEARCH_JIKKEN == 2	//+++
		CHAIN_MSG_MAP(CChevronHandler<CDonutSearchBar >)		//*+++
	  #endif
	ALT_MSG_MAP(1)
		MSG_WM_CHAR 		(OnChar 		 )
		MSG_WM_KEYDOWN		(OnKeywordKeyDown)
		NOTIFY_CODE_HANDLER_EX(CBN_DROPDOWN , OnKeywordCbnDropDown)
	ALT_MSG_MAP(2)
		MSG_WM_KEYDOWN		(OnEngineKeyDown  )
		MSG_WM_RBUTTONUP	(OnEngineRButtonUp)
		MSG_WM_SETFOCUS 	(OnEngineSetFocus )
		MSG_WM_KILLFOCUS	(OnEngineKillFocus)
		MESSAGE_HANDLER 	(WM_CTLCOLORLISTBOX, OnCtlColor 	  )
	ALT_MSG_MAP(3)
		MESSAGE_HANDLER 	(WM_CTLCOLORLISTBOX, OnCtlColorListBox)
	END_MSG_MAP()


private:
	LRESULT OnEraseBkgnd(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL &bHandled);
	LRESULT OnToolTipText(int idCtrl, LPNMHDR pnmh, BOOL & /*bHandled*/);

	void	OnCommand(UINT uFlag, int nID, HWND hWndCtrl);
	void	_OnCommand_SearchWeb(CString &str, int no=-1);
	void	_OnCommand_SearchHilight(CString &str);
	void	_OnCommand_SearchPage(BOOL bForward, int no=-1);

public:
	CString RemoveShortcutWord(CString &str);

private:
	LRESULT OnSize(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL &bHandled);
	void	InitToolBar(/*+++ UINT nImageBmpID, UINT nHotImageBmpID,*/ int cx, int cy, COLORREF clrMask, UINT nFlags = ILC_COLOR24);
	void	init_search_word_button_jikkenVersion();	//+++ y[W̕ŁAwʒu/{^ŒP邽߂̎.

	CString GetSkinSeachBarPath(BOOL bHot);
	LRESULT OnInitDialog(HWND hWnd, LPARAM lParam);

	//Xbh𗘗păR{{bNXɃf[^o^(INI̓ǂݍ݂ɎԂ邽)
	static UINT WINAPI _SearchThread(void* lpParam);
	bool	IsAliveSearchThread() const;

	void	checkToolBarWords();				//+++
	void	toolBarAddButtons(bool chk=0);		//+++
	int		addDefaultToolBarIcon(unsigned n);	//+++
	void	toolBarAddWordTbl(std::vector<CString>& tbl);	//+++


public:
	void	RefreshEngine() { _InitialEngine(m_cmbEngine.m_hWnd); }


private:
	void	OnDestroy();
	void	OnEngineKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags);
	void	OnChar(UINT nChar, UINT nRepCnt, UINT nFlags);

	LRESULT OnCtlColorListBox(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL &bHandled);
	void	OnKeywordKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags);
	LRESULT OnKeywordCbnDropDown(LPNMHDR pnmh);
	BOOL	DeleteKeywordHistory();

	struct	_Function_MakeSearchFileListMenu;

	void	OnEngineRButtonUp(UINT nFlags, CPoint point);
	void	OnEngineSetFocus(HWND hWndBefore);
	void	OnEngineKillFocus(HWND hWndNew);
	void	OnMouseMove(UINT nFlags, const CPoint& pt);

  #if 0
	void	OnSelDblClkForEngine(UINT code, int id, HWND hWnd); 	///+++ GWỈ... son_.
  #endif

	///+++ GWỈ... son_...ǁAƂLp.
	void	OnSelChangeForEngine(UINT code, int id, HWND hWnd);

	void	OnSelChange(UINT code, int id, HWND hWnd);
	void	OnLButtonDown(UINT nFlags, const CPoint& pt);
	void	OnLButtonUp(UINT nFlags, const CPoint& pt);

	void	UpdateLayout(const CPoint& pt);
	void	UpdateLayout2(const CPoint& pt);

public: //+++ Ƃprivateɖ߂Ƃ肠eXg.
	void	_AddToSearchBoxUnique(const CString &strURL);

private:
	void	_OnEnterKeyDown(int flag);

	LRESULT OnCtlColor(UINT /*uMsg*/, WPARAM wParam, LPARAM lParam, BOOL &bHandled);
	void	OnItemSelected(const CString& str);

public:
	static CString	GetSearchIniPath();

public:
	void		OpenSearch(CString strWord, CString strSearchEng, int &nLoopCnt, BOOL &bFirst);

  #if 1 	//+++ ".url"ɋLqgł̌ɑΉ邽߁Aǉ
	bool		GetOpenURLstr(CString& strOpenURL, const CString& strWord0, CIniFileI& pr, const CString& frontURL0);
  #endif


private:
	void		OpenSearchGroup(const CString& strWord, const CString& strSearchEng, int &nLoopCnt, BOOL &bFirst);
	void		EncodeString(CString &str, int dwEncode);	//minit
	void		ShortcutSearch(CString &strWord, CString &strSearchEng);
	CString 	GetShortcutWord(const CString& strSearchEng);

	static void _InitialEngine(LPVOID lpV);
	static void _InitialKeyword(LPVOID lpV);

	int 		ResizeBar(int difA, int difB);						//+++

public:
	BYTE		PreTranslateMessage(MSG *pMsg);
	CEdit		GetEditCtrl();
	void		SetFocusToEngine();


private:
	void		SaveHistory();


public:
	DROPEFFECT	OnDragEnter(IDataObject *pDataObject, DWORD dwKeyState, CPoint /*point*/);
	DROPEFFECT	OnDragOver(IDataObject *pDataObject, DWORD dwKeyState, CPoint /*point*/, DROPEFFECT dropOkEffect);
	void		OnDragLeave();

private:
	void		_DrawDragEffect(bool bRemove);

public:
	DROPEFFECT	OnDrop(IDataObject *pDataObject, DROPEFFECT dropEffect, DROPEFFECT dropEffectList, CPoint /*point*/);
	void		SetFont(HFONT hFont, BOOL bRedraw = TRUE);

private:
	void		_SetVerticalItemCount(CComboBox &cmb, int count);
	void		_InitCombo();						//minit

public:
	void		ShowToolBarIcon(BOOL flag);

public:
	void		SearchWeb();
	void		SearchHilight();
	void		SearchPage(BOOL bForward);
	BOOL		GetToolIconState();
	void		FilterString(CString &str) { str.Replace( _T("@"), _T(" ") ); }

	void		ReloadSkin(int nCmbStyle);
	void		SetComboStyle(int nCmbStyle);

	//+++ ܂C悭Ȃ...蔲ŗp.
	static CDonutSearchBar* GetInstance() { return s_pThis_; }

#if SEARCH_JIKKEN == 1	//+++
private:
	LRESULT 	OnChevronPushed(int /*idCtrl*/, LPNMHDR pnmh, BOOL &bHandled);
	CMenuHandle PrepareChevronMenu();
	void		CleanupChevronMenu(CMenuHandle menu, LPNMREBARCHEVRON lpnm);
	void		DisplayChevronMenu(CMenuHandle menu, LPNMREBARCHEVRON lpnm);

#elif SEARCH_JIKKEN == 2	//+++
public:
	LRESULT 	OnChevronPushed(int /*idCtrl*/, LPNMHDR pnmh, BOOL & bHandled); 	//+++
	HMENU		ChevronHandler_OnGetChevronMenu(int nCmdID, HMENU &hMenuDestroy);	//+++
	void		Chevronhandler_OnCleanupChevronMenu();		//+++

private:
	HMENU		_GetDropDownMenu(int nCmdID, bool &bDestroy, bool &bSubMenu);
#endif
};



#endif	// DONUTSEARCHBAR_H
