/**
 *	@file	DLControlOption.cpp
 *	brief	donut̃IvV : "uEU"
 */

#include "stdafx.h"
#include "DLControlOption.h"
#include "../IniFile.h"
#include "MainOption.h" 				//+++ Ώ


using namespace MTL;


//+++ Donut.cppړ.
TCHAR	CDLControlOption::s_szUserAgent[MAX_PATH];					// UDT DGSTR



DWORD CDLControlOption::s_dwDLControlFlags	   = DLCTL_BGSOUNDS | DLCTL_VIDEOS | DLCTL_DLIMAGES ;	//+++ 0ȊO̒lɕύX.
DWORD CDLControlOption::s_dwExtendedStyleFlags = DVS_EX_FLATVIEW | DVS_EX_MOUSE_GESTURE ;			//+++ 0ȊO̒lɕύX.



void CDLControlOption::GetProfile()
{
	CIniFileI	pr( g_szIniFileName, _T("Browser") );

	if (pr.QueryValue( s_dwDLControlFlags, _T("DLControl_Flags") ) != ERROR_SUCCESS)
		s_dwDLControlFlags = DLCTL_DEFAULT;

	// UDT DGSTR
	DWORD		dwCount = MAX_PATH;

	if (pr.QueryValue(s_szUserAgent, _T("UserAgent"), &dwCount) != ERROR_SUCCESS)
		::lstrcpy( s_szUserAgent, _T("") );
	// ENDE

	// UH
	pr.QueryValue( s_dwExtendedStyleFlags, _T("ViewStyle") );
}



void CDLControlOption::WriteProfile()
{
	CIniFileO	pr( g_szIniFileName, _T("Browser") );
	pr.SetValue( s_dwDLControlFlags, _T("DLControl_Flags") );
	pr.SetValue( s_szUserAgent, _T("UserAgent") ); // UDT DGSTR

	// UH
	pr.SetValue( s_dwExtendedStyleFlags, _T("ViewStyle") );
}





/////////////////////////////////////////////////////////////////////////////
// CDLControlPropertyPage



// Constructor
CDLControlPropertyPage::CDLControlPropertyPage(HWND hMainWnd)
{
	m_hMainWnd = hMainWnd;
	_SetData();
}



// Overrides
BOOL CDLControlPropertyPage::OnSetActive()
{
	SetModified(TRUE);

	// UDT DGSTR
	if (m_edit.m_hWnd == NULL)
		m_edit.Attach( GetDlgItem(IDC_EDIT_USER_AGENT) );
	// ENDE

	return DoDataExchange(FALSE);
}



BOOL CDLControlPropertyPage::OnKillActive()
{
	return DoDataExchange(TRUE);
}



BOOL CDLControlPropertyPage::OnApply()
{
	if ( DoDataExchange(TRUE) ) {
		_GetData();
		return TRUE;
	} else {
		return FALSE;
	}
}



void CDLControlPropertyPage::_GetData()
{
	// update dl control flags
	CDLControlOption::s_dwDLControlFlags = 0;

	if (m_nBGSounds /*== 1*/)		CDLControlOption::s_dwDLControlFlags |= DLCTL_BGSOUNDS;
	if (m_nVideos	/*== 1*/)		CDLControlOption::s_dwDLControlFlags |= DLCTL_VIDEOS;
	if (m_nDLImages /*== 1*/)		CDLControlOption::s_dwDLControlFlags |= DLCTL_DLIMAGES;
	if (m_nRunActiveXCtls == 0) 	CDLControlOption::s_dwDLControlFlags |= DLCTL_NO_RUNACTIVEXCTLS;
	if (m_nDLActiveXCtls  == 0) 	CDLControlOption::s_dwDLControlFlags |= DLCTL_NO_DLACTIVEXCTLS;
	if (m_nScripts		  == 0) 	CDLControlOption::s_dwDLControlFlags |= DLCTL_NO_SCRIPTS;
	if (m_nJava 		  == 0) 	CDLControlOption::s_dwDLControlFlags |= DLCTL_NO_JAVA;

	// UH
	CDLControlOption::s_dwExtendedStyleFlags = 0;
	if (m_nNaviLock    /* == 1*/)	CDLControlOption::s_dwExtendedStyleFlags |= DVS_EX_OPENNEWWIN;
	if (m_nFlatView    /* == 1*/)	CDLControlOption::s_dwExtendedStyleFlags |= DVS_EX_FLATVIEW;
	if (m_bMsgFilter   /* == 1*/)	CDLControlOption::s_dwExtendedStyleFlags |= DVS_EX_MESSAGE_FILTER;
	if (m_bMouseGesture/* == 1*/)	CDLControlOption::s_dwExtendedStyleFlags |= DVS_EX_MOUSE_GESTURE;
	if (m_bBlockMailto /* == 1*/)	CDLControlOption::s_dwExtendedStyleFlags |= DVS_EX_BLOCK_MAILTO;

  #if 1 //+++ ʂ̃IvVǗĂϐԎ؂肵Ēǉ.
	if (m_nNoCloseNL			)	CMainOption::s_dwMainExtendedStyle2 	 |= MAIN_EX2_NOCLOSE_NAVILOCK;		//+++ ǉ.
	else							CMainOption::s_dwMainExtendedStyle2 	 &= ~MAIN_EX2_NOCLOSE_NAVILOCK; 	//+++ ǉ.
  #endif

	SendMessage(m_hMainWnd, WM_COMMAND, ID_RESIZED, 0);
	m_edit.GetWindowText(CDLControlOption::s_szUserAgent, MAX_PATH);	// UDT DGSTR
}



void CDLControlPropertyPage::_SetData()
{
	m_nBGSounds 	  = (CDLControlOption::s_dwDLControlFlags & DLCTL_BGSOUNDS) != 0;		//+++ ? 1 : 0;
	m_nVideos		  = (CDLControlOption::s_dwDLControlFlags & DLCTL_VIDEOS  ) != 0;		//+++ ? 1 : 0;
	m_nDLImages 	  = (CDLControlOption::s_dwDLControlFlags & DLCTL_DLIMAGES) != 0;		//+++ ? 1 : 0;

	m_nRunActiveXCtls = (CDLControlOption::s_dwDLControlFlags & DLCTL_NO_RUNACTIVEXCTLS ) == 0; 	//+++ ? 0 : 1;
	m_nDLActiveXCtls  = (CDLControlOption::s_dwDLControlFlags & DLCTL_NO_DLACTIVEXCTLS	) == 0; 	//+++ ? 0 : 1;
	m_nScripts		  = (CDLControlOption::s_dwDLControlFlags & DLCTL_NO_SCRIPTS		) == 0; 	//+++ ? 0 : 1;
	m_nJava 		  = (CDLControlOption::s_dwDLControlFlags & DLCTL_NO_JAVA			) == 0; 	//+++ ? 0 : 1;

	m_nNaviLock 	  = (CDLControlOption::s_dwExtendedStyleFlags & DVS_EX_OPENNEWWIN	 ) != 0;	//+++ ? 1 : 0;
	m_nFlatView 	  = (CDLControlOption::s_dwExtendedStyleFlags & DVS_EX_FLATVIEW 	 ) != 0;	//+++ ? 1 : 0;
	m_bMsgFilter	  = (CDLControlOption::s_dwExtendedStyleFlags & DVS_EX_MESSAGE_FILTER) != 0;	//+++ ? 1 : 0;
	m_bMouseGesture   = (CDLControlOption::s_dwExtendedStyleFlags & DVS_EX_MOUSE_GESTURE ) != 0;	//+++ ? 1 : 0;
	m_bBlockMailto	  = (CDLControlOption::s_dwExtendedStyleFlags & DVS_EX_BLOCK_MAILTO  ) != 0;	//+++ ? 1 : 0;

  #if 1 //+++ ʂ̃IvVǗĂϐԎ؂肵Ēǉ.
	m_nNoCloseNL	   = (CMainOption::s_dwMainExtendedStyle2 & MAIN_EX2_NOCLOSE_NAVILOCK	  ) != 0;		//+++ ǉ.
  #endif

	// UDT DGSTR
	if (lstrlen(CDLControlOption::s_szUserAgent) != 0) {
		m_strUserAgent = CDLControlOption::s_szUserAgent;
	} else {
		TCHAR	szDefUserAgent[MAX_PATH];
		DWORD	size = MAX_PATH;
		::ObtainUserAgentString( 0 , szDefUserAgent , &size);
		// NOTE: Here , the other way.
		m_strUserAgent = szDefUserAgent;
	}
	// ENDE
}

