// TmpFavTreeView.cpp : Cve[V t@C
//

#include "stdafx.h"
#include "TmpFavGroup.h"
#include "TmpFavTreeView.h"
#include "MtlProfile.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif



/////////////////////////////////////////////////////////////////////////////
// CTmpFavTreeView

CTmpFavTreeView::CTmpFavTreeView() : m_dwExStyle(0)
{
}

CTmpFavTreeView::~CTmpFavTreeView()
{
	ASSERT(!m_nNewCount);
}


BEGIN_MESSAGE_MAP(CTmpFavTreeView, CTreeCtrl)
	//{{AFX_MSG_MAP(CTmpFavTreeView)
	ON_WM_DESTROY()
	ON_WM_LBUTTONDOWN()
	ON_WM_LBUTTONDBLCLK()
	ON_NOTIFY_REFLECT(NM_RCLICK, OnRclick)
	ON_NOTIFY_REFLECT(TVN_KEYDOWN, OnKeydown)
	ON_NOTIFY_REFLECT(TVN_ENDLABELEDIT, OnEndlabeledit)
	ON_WM_CREATE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()






//***************************************************************************
//I[o[Ch֐
//***************************************************************************


//ڂ̃AvP[V`f[^̈newŕp̃mۂ̂
//W̊֐ōڂ폜ƃ[N
//čڂ폜ꍇ̓I[o[Chȉ̊֐p
BOOL CTmpFavTreeView::DeleteItem(HTREEITEM hItem)
{
	BOOL bRet = DeleteChildItems(hItem);
	if(!bRet) return FALSE;

	FavGroupInfo *pInfo = (FavGroupInfo*)GetItemData(hItem);
	if(pInfo)
		FreeDataStruct(pInfo);
	return CTreeCtrl::DeleteItem(hItem);
}

BOOL CTmpFavTreeView::DeleteAllItems()
{
	return DeleteChildItems(TVI_ROOT);
}


//***************************************************************************
//Privateo
//***************************************************************************

//wACe̍ڂSč폜
BOOL CTmpFavTreeView::DeleteChildItems(HTREEITEM hParent) 
{
	//ċAIɎqACe폜
	BOOL bRet;
	HTREEITEM hChild, hChildNext;

	hChild = GetChildItem(hParent);
	if(hChild){
		bRet = DeleteChildItems(hChild);
		if(!bRet) return FALSE;

		while((hChildNext = GetNextSiblingItem(hChild)) != NULL){
			bRet = DeleteItem(hChild);
			if(!bRet) return FALSE;

			bRet = DeleteChildItems(hChildNext);
			if(!bRet) return FALSE;
			hChild = hChildNext;
		}
		bRet = DeleteItem(hChild);
		if(!bRet) return FALSE;
	}
	return TRUE;
}

//CɓO[vc[ɒǉ
BOOL CTmpFavTreeView::InsertFavGroup(CString &strGroupTitle, CString &strFilePath)
{
	HTREEITEM hItem = InsertItem(strGroupTitle,0,1,TVI_ROOT);
	if(!hItem) return FALSE;
	SetItemData(hItem,(DWORD)NULL);

	return InsertFavGroupItem(strFilePath,hItem);
}

//CɓO[v̍ڂ݂̂w肵O[vACẻɒǉ
BOOL CTmpFavTreeView::InsertFavGroupItem(CString &strFilePath, HTREEITEM hParent)
{
	int nCount=0;
	FavGroupInfo **infos = ReadFavGroupFile(strFilePath,&nCount); //͕Kdelete []
	if(infos == NULL) return FALSE;

	int nIndex=0;;
	CString strUrlTitle;
	HTREEITEM hItemChild;
	
	for(int i=0; i<nCount; i++){
		FavGroupInfo *pInfo = infos[i];
		
		if(pInfo->strTitle.IsEmpty()){
			hItemChild = InsertItem(pInfo->strLocation,2,2,hParent);
		}else{
			hItemChild = InsertItem(pInfo->strTitle,2,2,hParent); //^CgƂURL\
		}
		SetItemData(hItemChild,(DWORD)pInfo);
	}

	delete [] infos; //
	return TRUE;
}

//CɓO[vt@CJẴf[^i[zԂ
//̔z͎gIdelete []邱
FavGroupInfo **CTmpFavTreeView::ReadFavGroupFile(CString &strFilePath, int *pnCount)
{
	CIniSection pr;
	
	DWORD dwCount=0;
	pr.Open(strFilePath,_T("Header"));
	pr.QueryValue(dwCount,_T("Count"));
	pr.Close();

	if(dwCount == 0) return NULL;
	FavGroupInfo **infos = new FavGroupInfo*[dwCount]; //z̃m

	CString strLocation, strTitle;
	int nCount = dwCount;
	for(int i=0; i<nCount; i++){
		GetGroupItemData(strFilePath, i, strLocation, strTitle);
		infos[i] = AllocDataStruct(); //ACẽm
		infos[i]->strIniFile = strFilePath;
		infos[i]->strLocation = strLocation;
		infos[i]->strTitle = strTitle;
		infos[i]->strSection.Format("%s%d",PREFIXSECTION,i);
		infos[i]->bUseIniStyle = TRUE;
	}
	
	*pnCount = nCount; 
	return infos; 
}

//init@CACeɊւ擾
void CTmpFavTreeView::GetGroupItemData(CString& strDfgFile, int nSection, CString& strLocation, CString &strTitle)
{
	int bufsize=1024;
	DWORD dwGetSize=bufsize;
	CString strKey;
	CIniSection pr;

	strKey.Format(_T("%s%d"),PREFIXSECTION,nSection);
	pr.Open(strDfgFile,strKey);
	pr.QueryValue(strTitle.GetBuffer(bufsize),_T("Title"),&dwGetSize);
	strTitle.ReleaseBuffer();

	dwGetSize=bufsize;
	pr.QueryValue(strLocation.GetBuffer(bufsize),_T("Location_URL"),&dwGetSize);
	strLocation.ReleaseBuffer();
	pr.Close();
}

//GNXv[EX^Cȃt@Cs
BOOL CTmpFavTreeView::FileOperation(CString& strFromFilePath, CString& strToFilePath, int nOperate, int nFlag)
{
	TCHAR bufTo[MAX_PATH+2], bufFrom[MAX_PATH+2];
	LPTSTR lpstrFrom, lpstrTo;

	if(strFromFilePath.IsEmpty()) return FALSE;
	ZeroMemory(bufFrom,sizeof(TCHAR) * MAX_PATH+2); //2̃k
	CopyMemory(bufFrom,strFromFilePath.GetBuffer(0),strFromFilePath.GetLength());
	lpstrFrom = bufFrom;

	if(!strToFilePath.IsEmpty()){
		ZeroMemory(bufTo,sizeof(TCHAR) * MAX_PATH+2); //2̃k
		CopyMemory(bufTo,strToFilePath.GetBuffer(0),strToFilePath.GetLength());
		lpstrTo = bufTo;
	}else{
		lpstrTo = NULL;
	}
	SHFILEOPSTRUCT fop = { m_hWnd, nOperate, lpstrFrom, lpstrTo, 
							nFlag, FALSE, NULL, NULL };
	return (::SHFileOperation(&fop) == 0 && !fop.fAnyOperationsAborted );
}

//ACȅۑ\̂̃mۂ
FavGroupInfo *CTmpFavTreeView::AllocDataStruct()
{
	m_nNewCount++;
	return new FavGroupInfo;
}

//ŊmۂJ
void CTmpFavTreeView::FreeDataStruct(FavGroupInfo *ptr)
{
	m_nNewCount--;
	delete ptr;
}


//***************************************************************************
//Publico
//***************************************************************************

/////////////////////////////////////////////////////////////////////////////
//Sʏ
/////////////////////////////////////////////////////////////////////////////

//wtH_̂CɓO[vr[ɓo^
BOOL CTmpFavTreeView::LoadFavGroups(CString &strFolder)
{
	if(::GetFileAttributes(strFolder) == 0xFFFFFFFF)
		return FALSE;
	if(!DeleteAllItems())
		return FALSE;

	CString strMatch = strFolder + "*.dfg";

	//.dfgŏIt@CTēo^
	CFileFind find;
	if(find.FindFile(strMatch)){
		BOOL bContinue = TRUE;
		while(bContinue){
			bContinue = find.FindNextFile();
			if(!find.IsDirectory())
				InsertFavGroup(find.GetFileTitle(),find.GetFilePath());
		};
	}

	//łɃ\[g
	SortChildren(NULL);

	m_strDataFolder = strFolder;

	return TRUE;
}

//gX^C擾
DWORD CTmpFavTreeView::GetExtendedStyle()
{
	return m_dwExStyle;
}

//gX^Cݒ
void CTmpFavTreeView::SetExtendedStyle(DWORD dwStyle)
{
	m_dwExStyle = dwStyle;
}

/////////////////////////////////////////////////////////////////////////////
//CɓO[v
/////////////////////////////////////////////////////////////////////////////

//IO[vJ
BOOL CTmpFavTreeView::OpenFavGroup()
{
	HTREEITEM hItem = GetSelectedItem();
	if(hItem == NULL){
		return FALSE;
	}else if(GetItemData(hItem)){
		hItem = GetParentItem(hItem);
		if(hItem == NULL)
			return FALSE;
	}
	return OpenFavGroup(hItem);
}

//w肵O[vJ
BOOL CTmpFavTreeView::OpenFavGroup(HTREEITEM hItem)
{
	CString strFileName = m_strDataFolder + GetItemText(hItem);
	if(::GetFileAttributes(strFileName) == 0xFFFFFFFF)
		return FALSE;
	return OpenFavGroup(strFileName);
}

//w肵CɓO[vt@CJ
BOOL CTmpFavTreeView::OpenFavGroup(CString &strFileName)
{
	CDonutApi Donut;
	if(Donut.IsNull())
		return FALSE;

	_bstr_t bstrFileName = strFileName;
	BOOL bFlag = (m_dwExStyle&TMPFAV_CLOSE) ? TRUE : FALSE;
	Donut.m_pDonut->LoadGroup(bstrFileName,bFlag);

	return TRUE;
}

//JĂ^uXibvVbgƂĕۑ
void CTmpFavTreeView::SaveGroup()
{
	CDonutApi Donut;
	if(Donut.IsNull()) return;

	CTime time = CTime::GetCurrentTime();
	CString strTime = time.Format(_T("%Y%m%d_%H%M%S")); //t@C͎ԂɊÂ
	CString strFileName = m_strDataFolder +  strTime + _T(".dfg");
	_bstr_t bstrFileName = strFileName;
	Donut.m_pDonut->SaveGroup(bstrFileName);
	InsertFavGroup(strTime,strFileName);
}

//IĂO[vڂ폜
void CTmpFavTreeView::DeleteGroup() 
{
	HTREEITEM hItem = GetSelectedItem();
	if(!hItem) return;
	if(GetItemData(hItem)){
		hItem = GetParentItem(hItem);
		if(!hItem) return;
	}

	DeleteGroup(hItem);
}

//w肵O[v폜it@C폜j
void CTmpFavTreeView::DeleteGroup(HTREEITEM hItem) 
{
	CString strDfgFile = m_strDataFolder + GetItemText(hItem) + _T(".dfg");

	int nFlag=0;
	if(!(::GetAsyncKeyState(VK_SHIFT)&0x80000000))	//VtgĂƂ͒ō폜
		nFlag |= FOF_ALLOWUNDO;						//łȂƂ̓S~s

	BOOL bOk = FileOperation(strDfgFile, CString(), FO_DELETE, nFlag);

	if(bOk)
		DeleteItem(hItem);
		
}

//IO[v̖OύXit@CɂKpj
void CTmpFavTreeView::RenameGroup()
{
	HTREEITEM hItem = GetSelectedItem();
	if(!hItem) return;
	if(GetItemData(hItem)) return;

	RenameGroup(hItem);
}

//w肵O[v̖OύXit@CɂKpj
void CTmpFavTreeView::RenameGroup(HTREEITEM hItem)
{
	//xҏWł悤ɂ
	LONG lStyle = GetWindowLong(m_hWnd,GWL_STYLE);
	lStyle |= TVS_EDITLABELS;
	SetWindowLong(m_hWnd,GWL_STYLE,lStyle);
	EditLabel(hItem);
	//OnEndLabelEditł܂ҏWłȂ悤ɂ
}


/////////////////////////////////////////////////////////////////////////////
//CɓO[v̎qACe
/////////////////////////////////////////////////////////////////////////////

//O[v̎w肵ڂJ
BOOL CTmpFavTreeView::OpenGroupItem(HTREEITEM hItem)
{
	CDonutApi Donut;
	if(!Donut.IsNull()){
		FavGroupInfo *pInfo = (FavGroupInfo *)GetItemData(hItem);
		if(pInfo){
			_bstr_t bstrLocation = pInfo->strLocation;
			BOOL bFlagActive = (m_dwExStyle&TMPFAV_ACTIVE) ? TRUE : FALSE;

			//dlJ̈̎g͉܂񂪂ȊŁ
			_ExInfo ExInfo;
			ExInfo.lpstrIniFile = pInfo->strIniFile.GetBuffer(0);
			ExInfo.lpstrSection = pInfo->strSection.GetBuffer(0);
			ExInfo.bUseIniStyle = TRUE;
			Donut.m_pDonut->NewWindow3(bstrLocation,bFlagActive,0, (int *)&ExInfo);

			return TRUE;
		}
	}
	return FALSE;
}

//O[vւ̃ANeBu^u̒ǉ
void CTmpFavTreeView::AddItemToGroup() 
{
	//O[v̎擾
	HTREEITEM hItem = GetSelectedItem();
	if(!hItem) return;
	if(GetItemData(hItem) != 0){
		hItem = GetParentItem(hItem);
		if(!hItem) return;
	}

	//O[vւ̒ǉ
	CString strDfgFile = m_strDataFolder + GetItemText(hItem) + _T(".dfg");
	_bstr_t bstrDfgFile = strDfgFile;
	CDonutApi Donut;
	if(Donut.IsNull()) return;
	if(Donut.m_pDonut->TabIndex == -1) return;
	int nIndex = Donut.m_pDonut->AddGroupItem(bstrDfgFile,Donut.m_pDonut->TabIndex);
	if(nIndex == -1) return;

	//Xgւ̔f
	CString strLocation, strTitle;
	GetGroupItemData(strDfgFile,nIndex-1,strLocation,strTitle);

	HTREEITEM hItemChild;
	if(strTitle.IsEmpty())
		hItemChild = InsertItem(strLocation,2,2,hItem);
	else
		hItemChild = InsertItem(strTitle,2,2,hItem);
	FavGroupInfo *pInfo = AllocDataStruct();
	pInfo->strIniFile = strDfgFile;
	pInfo->strSection.Format(_T("%s%d"),PREFIXSECTION,nIndex);
	pInfo->strLocation = strLocation;
	pInfo->strTitle = strTitle;
	SetItemData(hItemChild,(DWORD)pInfo);

}

//IACe폜
void CTmpFavTreeView::DeleteGroupItem()
{
	//O[v̎擾
	HTREEITEM hItem = GetSelectedItem();
	if(!hItem) return;
	if(GetItemData(hItem) == 0) return;

	DeleteGroupItem(hItem);
}

//w肵ACe폜
void CTmpFavTreeView::DeleteGroupItem(HTREEITEM hItem)
{
	CDonutApi Donut;
	if(Donut.IsNull()) return;

	FavGroupInfo *pInfo = (FavGroupInfo*)GetItemData(hItem);
	if(!pInfo) return;
	int nIndex = atoi(pInfo->strSection.Mid(PREFIXSIZE));

	HTREEITEM hParent = GetParentItem(hItem);
	if(!hParent) return;
	CString strGroupFile = m_strDataFolder + GetItemText(hParent) + _T(".dfg");
	_bstr_t bstrGroupFile = strGroupFile;
	int lRet = Donut.m_pDonut->DeleteGroupItem(bstrGroupFile,nIndex);
	if(lRet == 0) return;

	DeleteChildItems(hParent);
	InsertFavGroupItem(strGroupFile,hParent);
}

//IACe̐ݒs
void CTmpFavTreeView::SetItemOption()
{
	HTREEITEM hItem = GetSelectedItem();
	if(hItem == NULL || GetItemData(hItem) == 0)
		return;
	
	SetItemOption(hItem);
}

//w肵ACe̐ݒs
void CTmpFavTreeView::SetItemOption(HTREEITEM hItem)
{
	FavGroupInfo *info = (FavGroupInfo*)GetItemData(hItem);
	if(info == NULL) return;

	DWORD dwDLStyle, dwReloadStyle, dwExStyle;
	CApiExStyle apiStyle;

	CIniSection pr;
	pr.Open(info->strIniFile, info->strSection);
	pr.QueryValue(dwDLStyle,_T("DL_Control_Flags"));
	pr.QueryValue(dwReloadStyle,_T("Auto_Refresh_Style"));
	pr.QueryValue(dwExStyle,_T("Extended_Style"));
	
	apiStyle.SetApiExtendedStyle(dwDLStyle,dwExStyle,dwReloadStyle);
	CExStyleDialog dlg(apiStyle); 

	if(dlg.DoModal() != IDOK) return; //_CAO\

	//XV
	pr.SetValue(apiStyle.GetDLControlFlags(),_T("DL_Control_Flags"));
	pr.SetValue(apiStyle.GetAutoRefreshFlag(),_T("Auto_Refresh_Style"));
	pr.SetValue(apiStyle.GetExtendedStyleFlags(),_T("Extended_Style"));

	pr.Close();
}

//***************************************************************************
//bZ[Wnh
//***************************************************************************

//bZ[WnhO
BOOL CTmpFavTreeView::PreTranslateMessage(MSG* pMsg) 
{
	// TODO: ̈ʒuɌŗL̏ǉ邩A܂͊{NXĂяoĂ
	if(WM_KEYFIRST <= pMsg->message && pMsg->message <= WM_KEYLAST){
		//L[bZ[W͎ŏ
		TranslateMessage(pMsg);
		DispatchMessage(pMsg);
		return TRUE;
	}
	return CTreeCtrl::PreTranslateMessage(pMsg);
}

//EBhE
int CTmpFavTreeView::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	lpCreateStruct->style &= ~TVS_EDITLABELS; //[U[̃t@CҏW֎~

	if (CTreeCtrl::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	return 0;
}

//EBhE폜
void CTmpFavTreeView::OnDestroy() 
{
	DeleteAllItems(); //폜Ă܂܂ɃACejăJ
	CTreeCtrl::OnDestroy(); //폜
}

//NbN
void CTmpFavTreeView::OnLButtonDown(UINT nFlags, CPoint point) 
{
	UINT nRetFlag=0;
	HTREEITEM hItem = HitTest(point,&nRetFlag);
	if (hItem) {
		OpenGroupItem(hItem); //J[\ɍڂΊJ
	}

	CTreeCtrl::OnLButtonDown(nFlags, point);
}

//_uNbN
void CTmpFavTreeView::OnLButtonDblClk(UINT nFlags, CPoint point) 
{
	HTREEITEM hItem = HitTest(point);
	if(hItem && m_dwExStyle&TMPFAV_DBLCLICK){
		//IvVݒɂĂ͂CɓO[vJ
		CString strText = GetItemText(hItem);
		CString strDfgFile = m_strDataFolder + strText + _T(".dfg");
		OpenFavGroup(strDfgFile);
	}

	CTreeCtrl::OnLButtonDblClk(nFlags, point);
}

//ENbN
void CTmpFavTreeView::OnRclick(NMHDR* pNMHDR, LRESULT* pResult) 
{
	CPoint point, pointClient;
	GetCursorPos(&point);
	pointClient = point;
	ScreenToClient(&pointClient);

	//O[vACe𔻕ʂĂꂼ̃j[\
	HTREEITEM hItem = HitTest(pointClient);
	if(hItem){
		SelectItem(hItem);

		if(GetItemData(hItem)){
			//qiACej
			CMenu menu;
			menu.LoadMenu(IDR_ITEM);

			CMenu *pmenuSub = menu.GetSubMenu(0);
			pmenuSub->TrackPopupMenu(TPM_LEFTALIGN|TPM_TOPALIGN|TPM_LEFTBUTTON|TPM_RIGHTBUTTON,
									 point.x,point.y,GetParent(),NULL); 

			*pResult = 1;
			return;
		}else{

			//eiO[vj
			CMenu menu;
			menu.LoadMenu(IDR_GROUP);

			CDonutApi Donut;
			BOOL bTabExist = (!Donut.IsNull() && (Donut.m_pDonut->GetTabIndex() != -1));
			if(!bTabExist){
				menu.EnableMenuItem(ID_ADDITEMTOGROUP,MF_BYCOMMAND|MF_DISABLED|MF_GRAYED);
			}

			CMenu *pmenuSub = menu.GetSubMenu(0);
			pmenuSub->TrackPopupMenu(TPM_LEFTALIGN|TPM_TOPALIGN|TPM_LEFTBUTTON|TPM_RIGHTBUTTON,
									 point.x,point.y,GetParent(),NULL);

		}
	}
	//j[IɔR}hbZ[W͐eEBhEŏ

	*pResult = 0;
}

//L[ꂽ
void CTmpFavTreeView::OnKeydown(NMHDR* pNMHDR, LRESULT* pResult) 
{
	TV_KEYDOWN* pTVKeyDown = (TV_KEYDOWN*)pNMHDR;
	
	//^[L[ŊJ
	if(pTVKeyDown->wVKey == VK_RETURN){
		HTREEITEM hItem = GetSelectedItem();
		if(hItem){
			if(GetItemData(hItem)){
				OpenGroupItem(hItem);
			}else{
				OpenFavGroup(hItem);
			}
		}
	}

	*pResult = 0;
}

//xҏWI
void CTmpFavTreeView::OnEndlabeledit(NMHDR* pNMHDR, LRESULT* pResult) 
{
	TV_DISPINFO* pTVDispInfo = (TV_DISPINFO*)pNMHDR;
	*pResult = 0;

	CString strBadChar = _T("*\\|<>:/?\"");

	CString strText;
	if(pTVDispInfo->item.pszText == NULL) return;

	//OɎgȂĂȂʂ
	strText = pTVDispInfo->item.pszText;
	if(strText.FindOneOf(strBadChar) != -1){
		CString strErr;
		strErr.Format(_T("%s ͖OɎgp邱Ƃ͂łB"),strBadChar);
		MessageBox(strErr,_T("G["));
		return;
	}else if(strText.IsEmpty()){
		return;
	}

	CString strFilePath = m_strDataFolder + strText;
	if(strFilePath.Find(_T(".dfg")) == -1)
		strFilePath += _T(".dfg");
	
	CString strBeforeName = m_strDataFolder + GetItemText(pTVDispInfo->item.hItem) + _T(".dfg");
	FileOperation(strBeforeName, strFilePath, FO_RENAME, FOF_ALLOWUNDO);
	
	//j[炵xҏWłȂ悤ɂ
	LONG lStyle = GetWindowLong(m_hWnd,GWL_STYLE);
	lStyle &= ~TVS_EDITLABELS;
	SetWindowLong(m_hWnd,GWL_STYLE,lStyle);

	*pResult = 1;
}



